//----------------------------------------------------------------------//
// NyanFi																//
//  o^fBNg/tH_ꗗ/Q								//
//----------------------------------------------------------------------//
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "MainFrm.h"
#include "FileInfDlg.h"
#include "DirDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRegDirDlg *RegDirDlg = NULL;

//---------------------------------------------------------------------------
#define SPITM_EXE 100	//ڂ͎st@C (SpDirList->Objects)

//---------------------------------------------------------------------------
__fastcall TRegDirDlg::TRegDirDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, RegDirListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
	EnvVarList	 = new TStringList();
	SpDirList	 = new TStringList();
	SpDirBuff	 = new TStringList();

	IsSpecial  = false;
	ToFilter   = false;
	KeyHandled = false;
	IsAddMode  = IsSelect = false;
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormShow(TObject *Sender)
{
	Caption = IsSpecial? "tH_ꗗ" : "o^fBNg";
	CmdStr	= EmptyStr;

	OpeToolBar->Visible      = IsSpecial;
	ShowIconAction->Visible  = IsSpecial;
	AddNyanFiAction->Visible = IsSpecial;
	AddPathAction->Visible   = IsSpecial;

	if (IsSpecial) {
		setup_ToolBar(OpeToolBar);
		FilterEdit->Width = IniFile->ReadIntGen(_T("SpecialDirFilterWidth"),	200);

		set_MigemoAction(MigemoAction, _T("SpecialDirMigemo"));
		AndOrAction->Checked	= IniFile->ReadBoolGen(_T("SpecialDirFltAndOr"));
		ShowIconAction->Checked = IniFile->ReadBoolGen(_T("SpecialDirShowIcon"), true);
	}

	IniFile->LoadPosInfo(this, DialogCenter, (IsSpecial? (IsSelect? "SelSpecialDir" : "SpecialDirList") : ""));

	//wb_
	InitializeListHeader(RegDirHeader, _T("L[|O|ꏊ"));
	THeaderSections *sp = RegDirHeader->Sections;
	sp->Items[0]->MaxWidth	 = IsSpecial? 0 : 1000;
	sp->Items[1]->FixedWidth = IsSpecial;

	TListBox *lp = RegDirListBox;
	lp->Clear();
	set_StdListBox(lp, LBTAG_OPT_FOCS);
	set_UsrScrPanel(ListScrPanel);

	//tH_
	if (IsSpecial) {
		UseEnvVarAction->Visible = true;
		UseEnvVarAction->Checked = IniFile->ReadBoolGen(_T("SpecialDirUseEnv"));
		if (UseEnvVarAction->Checked) lp->Tag |= LBTAG_OPT_SDIR;
		AddNyanFiAction->Checked = IniFile->ReadBoolGen(_T("SpecialDirAddNyanFi"));
		AddPathAction->Checked   = IniFile->ReadBoolGen(_T("SpecialDirAddPath"));

		//ϐϊXg쐬
		EnvVarList->Clear();
		EnvVarList->Add(cv_env_var("%APPDATA%")		 	  + "\t%APPDATA%");
		EnvVarList->Add(cv_env_var("%LOCALAPPDATA%")	  + "\t%LOCALAPPDATA%");
		EnvVarList->Add(cv_env_var("%PUBLIC%")			  + "\t%PUBLIC%");
		EnvVarList->Add(cv_env_var("%PROGRAMDATA%")		  + "\t%PROGRAMDATA%");
		EnvVarList->Add(cv_env_var("%USERPROFILE%")		  + "\t%USERPROFILE%");
		EnvVarList->Add(cv_env_var("%WINDIR%")			  + "\t%WINDIR%");
		EnvVarList->Add(cv_env_var("%PROGRAMFILES(X86)%") + "\t%PROGRAMFILES(X86)%");
		EnvVarList->Add(cv_env_var("%PROGRAMFILES%")	  + "\t%PROGRAMFILES%");
		EnvVarList->Add(cv_env_var("%PROGRAMW6432%")	  + "\t%PROGRAMW6432%");

		OptPanel->Visible	= false;
		BlankPanel->Visible = false;

		UpdateSpDirList(true);

		(ToFilter? (TWinControl*)FilterEdit : (TWinControl*)lp)->SetFocus();
	}
	//o^fBNg
	else {
		UseEnvVarAction->Visible = false;

		set_BtnMarkDark(HideOptBtn, UBMK_BDOWN);
		set_BtnMarkDark(ShowOptBtn, UBMK_BUP);
		HideOptBtn->Hint = LoadUsrMsg(USTR_HideOptPanel);
		ShowOptBtn->Hint = LoadUsrMsg(USTR_ShowOptPanel);

		MoveTopCheckBox->Checked   = IniFile->ReadBoolGen(_T("RegDirDlgMoveTop"));
		CursorTopCheckBox->Checked = IniFile->ReadBoolGen(_T("RegDirDlgCursorTop"));
		OptPanel->Visible		   = IniFile->ReadBoolGen(_T("RegDirDlgShowOpt"),	true);
		BlankPanel->Visible 	   = !OptPanel->Visible;

		sp->Items[0]->Width = IniFile->ReadInteger("RegDirGrid", "ColWidth0",	40);
		sp->Items[1]->Width = IniFile->ReadInteger("RegDirGrid", "ColWidth1",	200);
		adjust_HeaderSecWidth(RegDirHeader, 2);

		lp->Items->Assign(RegDirList);

		//^ǑʃXg
		if (CurStt->is_Find && CurStt->find_TAG) {
			lp->Items->Add(EmptyStr);
			lp->ItemIndex = lp->Count - 1;
			KeyEdit->Text  = EmptyStr;
			DescEdit->Text = EmptyStr;
			UnicodeString tags = CurStt->find_Keywd;
			if (!CurStt->find_And) tags = ReplaceStr(tags, ";", "|");
			DirEdit->Text = "#:" + tags;
		}
		//̑
		else {
			if (CursorTopCheckBox->Checked) {
				if (lp->Count==0) lp->Items->Add(EmptyStr);
				lp->ItemIndex  = 0;
				KeyEdit->Text  = EmptyStr;
				DescEdit->Text = EmptyStr;
			}
			else {
				int idx = IndexOfDir(CurPathName);
				if (idx!=-1) {
					lp->ItemIndex = idx;
					IsAddMode = false;
				}
				else {
					lp->Items->Add(EmptyStr);
					lp->ItemIndex  = lp->Count - 1;
					KeyEdit->Text  = EmptyStr;
					DescEdit->Text = EmptyStr;
				}
			}
			DirEdit->Text = CurPathName;
		}

		SetOptBtn();
		lp->SetFocus();
	}

	ListScrPanel->UpdateKnob();
	lp->DragMode = IsSpecial? dmManual : dmAutomatic;
	UserModule->InitializeListBox(lp, ListScrPanel);
	SelIndex = -1;

	SetDarkWinTheme(this);
	SetDarkWinTheme(FilterEdit);
	FilterEdit->Color = get_WinColor(!ToFilter);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	UserModule->UninitializeListBox();

	if (IsSpecial) {
		IniFile->WriteIntGen( _T("SpecialDirFilterWidth"),	FilterEdit->Width);
		IniFile->WriteBoolGen(_T("SpecialDirMigemo"),		MigemoAction);
		IniFile->WriteBoolGen(_T("SpecialDirFltAndOr"),		AndOrAction);
		IniFile->WriteBoolGen(_T("SpecialDirShowIcon"),		ShowIconAction);
		IniFile->WriteBoolGen(_T("SpecialDirUseEnv"),		UseEnvVarAction);
		IniFile->WriteBoolGen(_T("SpecialDirAddNyanFi"),	AddNyanFiAction);
		IniFile->WriteBoolGen(_T("SpecialDirAddPath"),		AddPathAction);

		SpDirList->Clear();
		SpDirBuff->Clear();
	}
	else {
		TListBox *lp = RegDirListBox;
		int i = 0;
		while (i<lp->Count) {
			UnicodeString lbuf = lp->Items->Strings[i];
			if (lbuf.IsEmpty()) {
				lp->Items->Delete(i);
			}
			else {
				if (is_separator(get_csv_item(lbuf, 1))) lp->Items->Strings[i] = ",-,";
				i++;
			}
		}
		RegDirList->Assign(lp->Items);

		//gpڂZp[^lĐ擪ֈړ
		if (MoveTopCheckBox->Checked) move_top_RegDirItem(SelIndex);

		IniFile->WriteBoolGen(_T("RegDirDlgMoveTop"),	MoveTopCheckBox);
		IniFile->WriteBoolGen(_T("RegDirDlgCursorTop"),	CursorTopCheckBox);
		IniFile->WriteBoolGen(_T("RegDirDlgShowOpt"),	OptPanel->Visible);

		THeaderSections *sp = RegDirHeader->Sections;
		IniFile->WriteInteger("RegDirGrid", "ColWidth0",	sp->Items[0]->Width);
		IniFile->WriteInteger("RegDirGrid", "ColWidth1",	sp->Items[1]->Width);
	}

	IniFile->SavePosInfo(this, (IsSpecial? (IsSelect? "SelSpecialDir" : "SpecialDirList") : ""));

	if (IsSelect) Action = caFree;

	IsSpecial = false;
	ToFilter  = false;
	IsAddMode = IsSelect = false;
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormDestroy(TObject *Sender)
{
	delete ListScrPanel;
	delete EnvVarList;
	delete SpDirList;
	delete SpDirBuff;
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormResize(TObject *Sender)
{
	if (!IsSpecial) SetOptBtn();

	RegDirListBox->Invalidate();
}

//---------------------------------------------------------------------------
//tH_ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::UpdateSpDirList(bool reload)
{
	if (!IsSpecial) return;

	//ꗗ擾([NXg`)
	if (reload) {
		SpDirList->Clear();
		usr_SH->get_SpecialFolderList(SpDirList);
		//SpDirList->Objects ŃZp[^(1`)
		int s_idx = 1;
		for (int i=0; i<SpDirList->Count; i++) {
			if (SameStr(SpDirList->Strings[i], "\t-")) {
				SpDirList->Objects[i] = (TObject*)(NativeInt)s_idx;
				s_idx++;
			}
		}

		//NyanFi ŗL
		if (AddNyanFiAction->Checked) {
			SpDirList->AddObject("\t-", (TObject*)5);		//Zp[^
			SpDirList->Add(ExePath   + "\tspX");
			SpDirList->Add(TempPathA + "\tꎞfBNg");
			if (!DownloadPath.IsEmpty())	SpDirList->Add(DownloadPath + "\t_E[h");
			if (usr_Migemo->Available)		SpDirList->Add(to_absolute_name(MigemoPath) + "\tMigemo");
			if (!SpiDir.IsEmpty())			SpDirList->Add(to_absolute_name(SpiDir) + "\tSusie vOC");
			if (!CmdGitExe.IsEmpty())		SpDirList->AddObject(CmdGitExe + "\tgit.exe", (TObject*)SPITM_EXE);

			//GfB^
			SpDirList->AddObject("\t-", (TObject*)6);
			if (!TextEditor.IsEmpty())		SpDirList->AddObject(TextEditor + "\teLXgGfB^", (TObject*)SPITM_EXE);
			if (!ImageEditor.IsEmpty())		SpDirList->AddObject(ImageEditor + "\tC[WGfB^", (TObject*)SPITM_EXE);
			if (!BinaryEditor.IsEmpty())	SpDirList->AddObject(BinaryEditor + "\toCiGfB^", (TObject*)SPITM_EXE);
			//̑̃GfB^
			std::unique_ptr<TStringList> x_lst(new TStringList());
			if (get_EtcEditorFiles(x_lst.get())>0) {
				for (int i=0; i<x_lst->Count; i++) {
					UnicodeString xnam = x_lst->ValueFromIndex[i];
					SpDirList->AddObject(xnam + ((i==0)? "\t|" : "\t") + get_base_name(xnam), (TObject*)SPITM_EXE);
				}
			}
			//Oc[
			if (get_ExtToolFiles(x_lst.get())>0) {
				SpDirList->AddObject("\t-", (TObject*)7);
				for (int i=0; i<x_lst->Count; i++) {
					UnicodeString xnam = x_lst->Strings[i];
					SpDirList->AddObject(xnam + "\t" + get_base_name(xnam), (TObject*)SPITM_EXE);
				}
			}
		}

		//PATH
		if (AddPathAction->Checked) {
			std::unique_ptr<TStringList> plst(new TStringList());
			TStringDynArray elst = split_strings_semicolon(GetEnvironmentVariable("PATH"));
			for (int i=0; i<elst.Length; i++) if (!elst[i].IsEmpty()) plst->Add(elst[i]);
			plst->Sort();
			SpDirList->AddObject("\t-", (TObject*)8);	//Zp[^
			for (int i=0; i<plst->Count; i++) SpDirList->Add(plst->Strings[i] + "\t");
		}
	}

	if (!FilterEdit->Text.IsEmpty()
		&& (!MigemoAction->Checked || (MigemoAction->Checked && FilterEdit->Text.Length()>=IncSeaMigemoMin)))
	{
		filter_List(SpDirList, SpDirBuff, FilterEdit->Text, MigemoAction->Checked, AndOrAction->Checked);
	}
	else {
		SpDirBuff->Assign(SpDirList);
	}

	//O̍ő啝擾
	TListBox *lp = RegDirListBox;
	int n_wd = 0;
	int i_wd = ShowIconAction->Checked? ScaledInt(20, this) : 0;
	for (int i=0; i<SpDirBuff->Count; i++) {
		UnicodeString dnam = get_post_tab(SpDirBuff->Strings[i]);
		if (!dnam.IsEmpty()) {
			int wd = lp->Canvas->TextWidth(dnam);
			if ((int)SpDirBuff->Objects[i]==SPITM_EXE) wd += i_wd;
			n_wd = std::max(n_wd, wd);
		}
	}

	THeaderSections *sp = RegDirHeader->Sections;
	sp->Items[0]->Width = 0;
	sp->Items[1]->Width = n_wd + ScaledInt(24, this);
	adjust_HeaderSecWidth(RegDirHeader, 2);

	lp->Items->Assign(SpDirBuff);
	lp->ItemIndex = IndexOfDir(CurPathName);
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderDrawSection(THeaderControl *HeaderControl,
	THeaderSection *Section, const TRect &Rect, bool Pressed)
{
	draw_SortHeader(HeaderControl, Section, Rect);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderResize(TObject *Sender)
{
	adjust_HeaderSecWidth((THeaderControl *)Sender, 2);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirHeaderSectionResize(THeaderControl *HeaderControl, THeaderSection *Section)
{
	adjust_HeaderSecWidth(HeaderControl, 2);
	RegDirListBox->Repaint();
}

//---------------------------------------------------------------------------
int __fastcall TRegDirDlg::IndexOfDir(UnicodeString dnam)
{
	int idx = -1;
	dnam = IncludeTrailingPathDelimiter(dnam);
	TListBox *lp = RegDirListBox;

	if (IsSpecial) {
		for (int i=0; i<lp->Count && idx==-1; i++) {
			UnicodeString pnam = get_pre_tab(lp->Items->Strings[i]);
			if ((int)lp->Items->Objects[i]==1) pnam = ExtractFilePath(pnam);
			if (SameText(pnam, dnam)) idx = i;
		}
		//v̂Ȃ΁Aԋ߂eT
		if (idx==-1) {
			UnicodeString max_nam;
			for (int i=0; i<lp->Count; i++) {
				UnicodeString pnam = get_pre_tab(lp->Items->Strings[i]);
				if ((int)lp->Items->Objects[i]==1) pnam = ExtractFilePath(pnam);
				if (StartsText(pnam, dnam)) {
					if (pnam.Length()>max_nam.Length()) {
						max_nam = pnam;
						idx = i;
					}
				}
			}
		}
	}
	else {
		for (int i=0; i<lp->Count && idx==-1; i++) {
			if (SameText(get_csv_item(lp->Items->Strings[i], 2), dnam)) idx = i;
		}
	}

	return idx;
}

//---------------------------------------------------------------------------
//J[\ʒuڂ̃pX擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TRegDirDlg::GetCurDirItem(
	bool dsp_sw,	//true = tH_̕\擾	(default = false)
	bool nam_sw,	//true = tH_t		(default = false)
	bool exe_sw)	//true = st@CƂĎ擾	(default = false)
{
	UnicodeString dnam;
	TListBox *lp = RegDirListBox;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		UnicodeString lbuf = lp->Items->Strings[idx];
		if (IsSpecial) {
			TStringDynArray itm_buf = split_strings_tab(lbuf);
			if (itm_buf.Length==2 && !itm_buf[0].IsEmpty()) {
				dnam = itm_buf[0];
				if ((int)lp->Items->Objects[idx]==1 && !exe_sw) {
					dnam = ExtractFilePath(dnam);
				}
				if (dsp_sw && UseEnvVarAction->Checked) {
					if (contained_wd_i(_T("TEMP|TMP"), itm_buf[1]))
						dnam = "%" + itm_buf[1] + "%";
					else
						dnam = ExcludeTrailingPathDelimiter(replace_str_by_list(dnam, EnvVarList));
				}
				if (nam_sw) dnam += ("\t" + itm_buf[1]);
			}
		}
		else {
			TStringDynArray itm_buf = get_csv_array(lbuf, REGDIR_CSVITMCNT, true);
			if (!is_separator(itm_buf[1])) dnam = itm_buf[2];
		}
	}

	return dnam;
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);

	TListBox *lp = RegDirListBox;

	//ĂяoL[H
	bool to_call = false;
	if (!IsSpecial) {
		for (int i=0; i<lp->Count && !to_call; i++) {
			to_call = SameText(KeyStr, get_tkn(lp->Items->Strings[i], ','));
		}
	}

	bool handled = true;
	if (to_call) {
		handled = false;
	}
	else if (equal_UP(KeyStr) && lp->ItemIndex==0) {
		lp->ItemIndex = lp->Count - 1;
	}
	else if (equal_DOWN(KeyStr) && lp->ItemIndex==lp->Count-1) {
		lp->ItemIndex = 0;
	}
	else if (contained_wd_i(KeysStr_Popup, KeyStr)) {
		show_PopupMenu(lp);
	}
	else if (IsSpecial && ExeCmdListBox(lp, cmd_F)) {
		;
	}
	else if (!IsSpecial && UserModule->ListBoxOpeItem(KeyStr)) {
		;
	}
	else if (StartsText("ContextMenu", cmd_F)) {
		show_PopupMenu(lp);
	}
	else if (IsSpecial && StartsText("IncSearch", cmd_F)) {
		FilterEdit->SetFocus();
	}
	//vpeB
	else if (USAME_TI(cmd_F, "PropertyDlg")) {
		UnicodeString dnam = GetCurDirItem();
		if (!dnam.IsEmpty() && !StartsText("shell:", dnam) && !StartsText("#:", dnam)) {
			pos_ListBoxItem(lp);
			ShowPropertyDialog(dnam);
		}
	}
	//GNXv[ŊJ
	else if (USAME_TI(cmd_F, "OpenByExp")) {
		ClearKeyBuff(true);		//OnKeyPress }~
		OpenByExpAction->Execute();
	}
	//ANZ[^ňړ
	else if (IsSpecial) {
		int s_idx = USAME_TI(KeyStr, "Alt+U")? 1 :
					USAME_TI(KeyStr, "Alt+V")? 2 :
					USAME_TI(KeyStr, "Alt+N")? 5 :
					USAME_TI(KeyStr, "Alt+E")? 6 :
					USAME_TI(KeyStr, "Alt+X")? 7 :
					USAME_TI(KeyStr, "Alt+P")? 8 : 0;
		if (s_idx>0) {
			for (int i=0; i<lp->Count; i++) {
				if ((int)lp->Items->Objects[i]==s_idx) {
					ListBoxSetIndex(lp, i + 1, true);
					break;
				}
			}
		}
		else {
			handled = false;
		}
	}
	else {
		handled = false;
	}

	if (handled) Key = 0;

	ListScrPanel->UpdateKnob();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	UnicodeString jdir, unam;
	bool found = false;
	SelIndex = -1;

	TListBox *lp = (TListBox*)Sender;
	if (Key==VK_RETURN) {
		jdir = GetCurDirItem(false, IsSelect, true);
		if (!jdir.IsEmpty()) {
			SelIndex = lp->ItemIndex;
			unam = get_csv_item(lp->Items->Strings[SelIndex], 3);
			found = true;
		}
	}
	else if (!IsSpecial && !is_KeyDown(VK_CONTROL)) {
		//YL[̓o^JEg
		int f_cnt = 0;
		UnicodeString k = Key;
		for (int i=0; i<lp->Count; i++) {
			TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[i], REGDIR_CSVITMCNT, true);
			if (SameText(k, itm_buf[0])) {
				jdir = itm_buf[2];
				unam = itm_buf[3];
				SelIndex = i;
				f_cnt++;
			}
		}

		if (f_cnt==0) {
			beep_Warn();
		}
		else if (f_cnt==1) {
			lp->ItemIndex = SelIndex;
			found = true;
		}
	}

	//m
	if (found) {
		if (IsSelect) {
			CmdStr = jdir;
			ModalResult = mrOk;
		}
		else {
			//st@C
			if (SelIndex!=-1 && (int)lp->Items->Objects[SelIndex]==SPITM_EXE) {
				CmdStr.sprintf(_T("JumpTo_\"%s\""), jdir.c_str());
				ModalResult = mrOk;
			}
			//tH_
			else if (StartsStr("shell:", jdir)) {
				CmdStr.sprintf(_T("OpenByExp_\"%s\""), jdir.c_str());
				ModalResult = mrOk;
			}
			//^O
			else if (remove_top_s(jdir, "#:")) {
				NyanFiForm->RecoverFileList2();
				CmdStr.sprintf(_T("FindTag_%s"), jdir.c_str());
				ModalResult = mrOk;
			}
			//Rs[^
			else if (is_computer_name(jdir)) {
				CmdStr.sprintf(_T("ShareList_\"%s\""), jdir.c_str());
				ModalResult = mrOk;
			}
			//ʏfBNg
			else {
				UnicodeString dnam = get_actual_path(jdir);
				if (!StartsStr("\\\\", dnam) && !is_dir_accessible(dnam)) {
					msgbox_ERR(USTR_CantAccessDir);
				}
				else {
					NyanFiForm->UpdateCurPath(dnam, -1, false, unam);
					ModalResult = mrOk;
				}
			}
		}
	}

	//tH_ꗗł̃CN^T[`
	if (IsSpecial && (_istalnum(Key) || Key==VK_SPACE || Key==VK_RETURN || is_KeyDown(VK_CONTROL))) Key = 0;
}
//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxDblClick(TObject *Sender)
{
	WideChar key = VK_RETURN;
	RegDirListBoxKeyPress(Sender, key);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxClick(TObject *Sender)
{
	if (IsSpecial || IsAddMode) return;

	int idx = RegDirListBox->ItemIndex;
	if (idx==-1) return;
	UnicodeString lbuf = RegDirListBox->Items->Strings[idx];
	if (!lbuf.IsEmpty()) {
		TStringDynArray itm_buf = get_csv_array(RegDirListBox->Items->Strings[idx], REGDIR_CSVITMCNT, true);
		if (is_separator(itm_buf[1])) itm_buf[0] = itm_buf[2] = EmptyStr;
		KeyEdit->Text  = itm_buf[0];
		DescEdit->Text = itm_buf[1];
		DirEdit->Text  = itm_buf[2] + (!itm_buf[3].IsEmpty()? ":" + itm_buf[3] : EmptyStr);
	}
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RegDirListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
	if (ModalResult!=mrNone) return;

	THeaderSections *sp = RegDirHeader->Sections;
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	bool is_irreg  = IsIrregularFont(cv->Font);
	TColor adj_col = AdjustColor(col_Folder, ADJCOL_LIGHT);

	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	TRect rc = Rect;
	if (ScrBarStyle>0) {
		rc.SetWidth(ListScrPanel->ParentPanel->Width);
		if (ListScrPanel->VisibleV) rc.Right -= (ListScrPanel->KnobWidth - 1);
	}

	UnicodeString lbuf = lp->Items->Strings[Index];
	if (!lbuf.IsEmpty()) {
		//tH_
		if (IsSpecial) {
			TStringDynArray itm_buf = split_strings_tab(lbuf);
			if (itm_buf.Length==2) {
				int xp = rc.Left + ScaledInt(4, this);
				int yp = rc.Top  + get_TopMargin2(cv);
				//Zp[^
				if (itm_buf[0].IsEmpty()) {
					draw_Separator(cv, rc);
					cv->Font->Color = col_Folder;
					UnicodeString snam;
					switch ((int)lp->Items->Objects[Index]) {
					case  1: snam = lp->Focused()? "<All Users (&U)> " : "<All Users> "; break;
					case  2: snam = lp->Focused()? "<ztH_ (&V)> " : "<ztH_> "; break;
					case  5: snam = lp->Focused()? "<NyanFi (&N)> " : "<NyanFi> "; break;
					case  6: snam = lp->Focused()? "<GfB^ (&E)> " : "<GfB^> "; break;
					case  7: snam = lp->Focused()? "<Oc[ (&X)> " : "<Oc[> "; break;
					case  8: snam = lp->Focused()? "<&PATH> " : "<PATH> "; break;
					default: snam = "";
					}
					if (!snam.IsEmpty()) {
						TRect tmp_rc = rc; tmp_rc.Left = xp; tmp_rc.Top = yp;
						::DrawText(cv->Handle, snam.c_str(), -1, &tmp_rc, DT_LEFT);
					}
				}
				//
				else {
					UnicodeString dnam = itm_buf[0];
					bool is_exe = ((int)lp->Items->Objects[Index]==SPITM_EXE);
					//ACR
					if (is_exe && ShowIconAction->Checked) {
						draw_SmallIconF(dnam, cv, xp, std::max(yp + (cv->TextHeight("Q") - ScaledInt(16, this))/2, 0), this);
						xp += ScaledInt(20, this);
					}
					//O
					cv->Font->Color = col_fgList;
					UnicodeString inam = itm_buf[1];
					bool brk = remove_top_s(inam, '|');
					cv->TextOut(xp, yp, inam);
					xp = sp->Items[1]->Width + 1;
					//ꏊ
					lp->Tag &= 0x7fff0000;
					lp->Tag |= xp;			//\ʒu Tag ɐݒ
					if (is_exe) dnam = ExtractFilePath(dnam);
					if (UseEnvVarAction->Checked) {
						if (contained_wd_i(_T("TEMP|TMP"), itm_buf[1]))
							dnam = "%" + itm_buf[1] + "%";
						else
							dnam = ExcludeTrailingPathDelimiter(replace_str_by_list(dnam, EnvVarList));
						if (remove_top_s(dnam, '%')) {
							UnicodeString envstr = "%" + split_tkn(dnam, '%') + "%";
							cv->Font->Color = adj_col;
							cv->TextOut(xp, yp, envstr);
							xp += get_TextWidth(cv, envstr, is_irreg) + ScaledInt(2, this);
						}
					}
					cv->Font->Color = (StartsStr("shell:", dnam))? adj_col : col_Folder;
					PathNameOut(dnam, cv, xp, yp, rc.Right - xp - ScaledInt(4, this));
					//؂
					if (brk) draw_separateLine(cv, rc);
				}
			}
		}
		//o^fBNg
		else {
			TStringDynArray itm_buf = get_csv_array(lbuf, REGDIR_CSVITMCNT, true);
			//Zp[^
			if (is_separator(itm_buf[1])) {
				draw_Separator(cv, rc);
			}
			//
			else {
				//L[
				cv->Font->Color = col_fgList;
				cv->Font->Style = cv->Font->Style << fsBold;
				int s_wd = cv->TextWidth(itm_buf[0]);
				int c_wd = sp->Items[0]->Width - 4;
				int xp = rc.Left + ScaledInt(2, this);
				int yp = rc.Top  + get_TopMargin2(cv);
				if (s_wd<c_wd) xp += (c_wd - s_wd)/2;	//Z^O
				cv->TextOut(xp, yp, itm_buf[0]);
				//O
				xp = sp->Items[0]->Width + 1;
				cv->Font->Style = cv->Font->Style >> fsBold;
				cv->TextOut(xp, yp, itm_buf[1]);
				xp += sp->Items[1]->Width + 1;
				//ꏊ
				lp->Tag &= 0x7fff0000;
				lp->Tag |= xp;			//\ʒu Tag ɐݒ
				UnicodeString dnam = itm_buf[2];
				if (StartsStr("#:", dnam)) {
					cv->Font->Color = adj_col;
					usr_TAG->DrawTags(dnam, cv, xp, yp, RevTagCololr? col_bgList : col_None);
				}
				else {
					if (remove_top_s(dnam, '%')) {
						UnicodeString envstr = "%" + split_tkn(dnam, '%') + "%";
						cv->Font->Color = adj_col;
						cv->TextOut(xp, yp, envstr);
						xp += get_TextWidth(cv, envstr, is_irreg) + 2;
					}
					cv->Font->Color = (StartsStr("shell:", dnam))? adj_col : col_Folder;
					PathNameOut(dnam, cv, xp, yp, rc.Right - xp - ScaledInt(4, this));
					if (!itm_buf[3].IsEmpty()) {
						out_TextEx(cv, xp, yp, " : ", adj_col);
						cv->Font->Color = col_fgList;
						cv->TextOut(xp, yp, itm_buf[3]);
					}
				}
			}
		}
	}

	//J[\
	draw_ListCursor2(lp, rc, Index, State);
}

//---------------------------------------------------------------------------
//ڂ̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::ChangeItemActionExecute(
	int chg_mod)	//ύX[h 0:ǉ/ 1:ύX/ 2:}
{
	UnicodeString dnam = DirEdit->Text;
	UnicodeString unam = split_user_name(dnam);

	if (chg_mod==0 && IndexOfDir(dnam)!=-1) {
		msgbox_WARN(LoadUsrMsg(USTR_Registered));
		return;
	}

	if (is_separator(DescEdit->Text)
		|| StartsText("shell:", dnam) || StartsText("#:", dnam)
		|| is_computer_name(dnam) || StartsStr("\\\\", dnam)
		|| dir_exists(get_actual_path(dnam)))
	{
		UnicodeString lbuf;
		if (is_separator(DescEdit->Text)) {
			lbuf = ",-,,";
		}
		else {
			if (!StartsText("shell:", dnam) && !StartsText("#:", dnam))
				dnam = IncludeTrailingPathDelimiter(dnam);
			lbuf = KeyEdit->Text.SubString(1, 1).UpperCase();
			lbuf.cat_sprintf(_T(",%s,%s,%s"),
				make_csv_str(DescEdit->Text).c_str(), make_csv_str(dnam).c_str(), make_csv_str(unam).c_str());
		}

		TListBox *lp = RegDirListBox;
		switch (chg_mod) {
		case 0:	//ǉ
			if (lp->Items->Strings[lp->Count - 1].IsEmpty())
				lp->Items->Strings[lp->Count - 1] = lbuf;
			else
				lp->Items->Add(lbuf);
			lp->ItemIndex = lp->Count - 1;
			break;
		case 1:	//ύX
			if (lp->ItemIndex==-1) return;
			lp->Items->Strings[lp->ItemIndex] = lbuf;
			break;
		case 2:	//}
			if (lp->ItemIndex==-1) return;
			lp->Items->Insert(lp->ItemIndex, lbuf);
			break;
		}

		int i = 0;
		while (i<lp->Count) {
			if (lp->Items->Strings[i].IsEmpty()) lp->Items->Delete(i); else i++;
		}

		lp->SetFocus();
		ListScrPanel->UpdateKnob();
		IsAddMode = false;
	}
	else msgbox_WARN(LoadUsrMsg(USTR_DirNotFound));
}

//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddItemActionExecute(TObject *Sender)
{
	ChangeItemActionExecute(0);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddItemActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (!IsSpecial && !DescEdit->Text.IsEmpty());
	if (!IsSpecial) Caption = IsAddMode? "o^fBNg(ǉ)" : "o^fBNg";
}
//---------------------------------------------------------------------------
//ύX/}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::EditItemActionExecute(TObject *Sender)
{
	ChangeItemActionExecute(IsAddMode? 2 : 1);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::EditItemActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	TListBox *lp = RegDirListBox;
	if (IsAddMode) {
		ap->Caption = "}";
		ap->Enabled = (!IsSpecial && lp->ItemIndex!=-1 && !DescEdit->Text.IsEmpty());
	}
	else {
		ap->Caption = "ύX";
		ap->Enabled = (!IsSpecial && lp->ItemIndex!=-1 && !lp->Items->Strings[lp->ItemIndex].IsEmpty());
	}
}
//---------------------------------------------------------------------------
//폜
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::DelItemActionExecute(TObject *Sender)
{
	TListBox *lp = RegDirListBox;
	delete_ListItem(lp);
	if (lp->Tag & LBTAG_OPT_FOCS) lp->SetFocus();
	ListScrPanel->UpdateKnob();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::DelItemActionUpdate(TObject *Sender)
{
	TListBox *lp = RegDirListBox;
	((TAction*)Sender)->Enabled =
		(!IsSpecial && lp->ItemIndex!=-1 && !lp->Items->Strings[lp->ItemIndex].IsEmpty());
}

//---------------------------------------------------------------------------
//fBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RefDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = DirEdit->Text;
	UnicodeString unam = split_user_name(dnam);
	if (UserModule->SelectDirEx(_T("o^fBNg"), dnam)) {
		DirEdit->Text = to_path_name(dnam) + (!unam.IsEmpty()? ":" + unam : EmptyStr);
	}
}
//---------------------------------------------------------------------------
//tH_̎Q
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::RefSpBtnClick(TObject *Sender)
{
	TRegDirDlg *SelSpDirDlg = new TRegDirDlg(this);		//Ƃɔj
	SelSpDirDlg->IsSpecial	= true;
	SelSpDirDlg->IsSelect	= true;
	if (SelSpDirDlg->ShowModal()==mrOk) {
		DirEdit->Text  = get_pre_tab(SelSpDirDlg->CmdStr);
		DescEdit->Text = get_post_tab(SelSpDirDlg->CmdStr);
		KeyEdit->SetFocus();
	}
}

//---------------------------------------------------------------------------
//pXRs[
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::CopyPathActionExecute(TObject *Sender)
{
	copy_to_Clipboard(ExcludeTrailingPathDelimiter(GetCurDirItem(IsSpecial)));
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::CopyPathActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !GetCurDirItem().IsEmpty();
}

//---------------------------------------------------------------------------
//ϐpăpX\
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::UseEnvVarActionExecute(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Checked = !ap->Checked;

	if (ap->Checked)
		RegDirListBox->Tag |= LBTAG_OPT_SDIR;
	else
		RegDirListBox->Tag &= ~LBTAG_OPT_SDIR;

	RegDirListBox->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::ToggleActionExecute(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Checked = !ap->Checked;
	UpdateSpDirList();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddNyanFiActionExecute(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Checked = !ap->Checked;
	UpdateSpDirList(true);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AddPathActionExecute(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Checked = !ap->Checked;
	UpdateSpDirList(true);
}

//---------------------------------------------------------------------------
//GNXv[ŊJ
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::OpenByExpActionExecute(TObject *Sender)
{
	UnicodeString dnam = GetCurDirItem();
	if (::ShellExecute(NULL, _T("explore"), dnam.c_str(), NULL, NULL, SW_SHOWNORMAL) > (HINSTANCE)32)
		ModalResult = mrOk;
	else
		msgbox_ERR(USTR_FaildExec);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::OpenByExpActionUpdate(TObject *Sender)
{
	UnicodeString dnam = GetCurDirItem();
	((TAction*)Sender)->Enabled = (!dnam.IsEmpty() && !StartsText("#:", dnam));
}

//---------------------------------------------------------------------------
//fBNg̃vpeB
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::PropertyActionExecute(TObject *Sender)
{
	UnicodeString dnam = GetCurDirItem();
	if (!dnam.IsEmpty()) ShowPropertyDialog(dnam);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::PropertyActionUpdate(TObject *Sender)
{
	UnicodeString dnam = GetCurDirItem();
	((TAction*)Sender)->Enabled = (!dnam.IsEmpty() && !StartsText("shell:", dnam) && !StartsText("#:", dnam));
}

//---------------------------------------------------------------------------
//AvP[V
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AppInfoActionExecute(TObject *Sender)
{
	FileInfoDlg->ShowModalEx(GetCurDirItem(false, false, true));
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::AppInfoActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	TListBox *lp = RegDirListBox;
	ap->Visible = (lp->ItemIndex!=-1 && (int)lp->Items->Objects[lp->ItemIndex]==1);
	ap->Enabled = ap->Visible && file_exists(GetCurDirItem(false, false, true));
}

//---------------------------------------------------------------------------
//ꗗ[NXgƂĕۑ
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SaveAsWorkActionExecute(TObject *Sender)
{
	UserModule->PrepareSaveDlg(LoadUsrMsg(USTR_SaveAs, _T("[NXg")).c_str(),
		F_FILTER_NWL, _T("SpecialDir.nwl"), WorkListPath);

	UnicodeString fnam = UserModule->SaveDlgExecute();
	if (!fnam.IsEmpty()) {
		TListBox *lp = RegDirListBox;
		std::unique_ptr<TStringList> lst(new TStringList());
		int s_cnt = 0;
		for (int i=0; i<lp->Count; i++) {
			UnicodeString lbuf = ReplaceStr(lp->Items->Strings[i], "\t|", "\t");
			if (get_pre_tab(lbuf).IsEmpty()) s_cnt++;
			if (s_cnt<2) lst->Add(lbuf);
		}

		if (!saveto_TextUTF8(fnam, lst.get())) msgbox_ERR(LoadUsrMsg(USTR_FaildSave, ExtractFileName(fnam)));
	}
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SaveAsWorkActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction *)Sender;
	ap->Visible = IsSpecial;
	ap->Enabled = IsSpecial;
}

//---------------------------------------------------------------------------
//ݒpl̊J
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::SetOptBtn()
{
	if (ScrBarStyle==0)
		set_ControlRBCorner(RegDirListBox, BlankPanel);
	else
		ListScrPanel->SetRBCornerPanel(BlankPanel);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::ChgOptBtnClick(TObject *Sender)
{
	OptPanel->Visible	= !OptPanel->Visible;
	BlankPanel->Visible = !OptPanel->Visible;
	ListScrPanel->UpdateKnob();
	SetOptBtn();
	if (!OptPanel->Visible) RegDirListBox->SetFocus();
}

//---------------------------------------------------------------------------
//tB^
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterBtnClick(TObject *Sender)
{
	FilterEdit->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterEditEnter(TObject *Sender)
{
	FilterEdit->Color = get_WinColor();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterEditExit(TObject *Sender)
{
	CloseIME(Handle);
	InvColIfEmpty(FilterEdit);
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterEditChange(TObject *Sender)
{
	UpdateSpDirList();
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);	if (KeyStr.IsEmpty()) return;
	TListBox *lp = RegDirListBox;

	if (equal_ENTER(KeyStr)) {
		lp->SetFocus();
		if (lp->Count==1) {
			WideChar key = VK_RETURN;
			RegDirListBoxKeyPress(lp, key);
			return;
		}
	}
	else if (contained_wd_i(KeysStr_ToList, KeyStr)) {
		lp->SetFocus();
	}
	else if (MovListBoxFromFilter(lp, KeyStr)) {
		;
	}
	else if (SameText(KeyStr, KeyStr_Migemo)) {
		MigemoAction->Checked = !MigemoAction->Checked;
	}
	else if (equal_ESC(KeyStr)) {
		ModalResult = mrCancel;
	}
	else return;

	lp->Invalidate();
	KeyHandled = true;
	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FilterEditKeyPress(TObject *Sender, System::WideChar &Key)
{
	if (KeyHandled || Key==VK_RETURN || Key==VK_ESCAPE) {
		KeyHandled = false;
		Key = 0;
	}
}

//---------------------------------------------------------------------------
void __fastcall TRegDirDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (!IsSpecial && USAME_TI(get_KeyStr(Key, Shift), "Alt+O")) {
		ChgOptBtnClick(NULL);
	}
	else {
		SpecialKeyProc(this, Key, Shift,
			IsSpecial? _T(HELPTOPIC_FL) _T("#SpecialDirList") : _T("hid00054.htm"));
	}
}
//---------------------------------------------------------------------------

